# norootforbuild
%define pversion	3.0.4
%define varnish_backend_secret	2013#${RANDOM}
Name:		varnish
Version:	3.0.4
Release:	2.1
#
License:	BSD
Group:		Productivity/Networking/Web/Proxy
#
BuildRoot:	%{_tmppath}/%{name}-%{version}-build
BuildRequires:	docutils ncurses-devel libxslt pcre-devel
BuildRequires:	gcc gcc-c++ bison flex autoconf automake libtool
BuildRequires:	readline-devel

%if 0%{?suse_version}
BuildRequires:	pkg-config
%endif

%if 0%{?centos_version} || 0%{?rhel_version} || 0%{?fedora_version}
BuildRequires:	pkgconfig
%endif

Requires:	gcc
Requires:	libvarnishapi1 = %{version}
%define _bindir      %{_sbindir}
%define pkg_home     %{_var}/lib/%{name}
%define pkg_logdir   %{_var}/log/%{name}
%define pkg_cachedir %{_var}/cache/%{name}
%define pkg_name     %{name}
#
URL:		http://www.varnish-cache.org/
Source:		http://downloads.sourceforge.net/varnish/varnish-%{pversion}.tar.bz2
Source2:	varnish.init
Patch0:		varnish-redhat-pid.patch
Patch2:		varnish-sysconfig.patch
Summary:	Varnish is a high-performance HTTP accelerator

%description
Varnish is an HTTP accelerator. An HTTP accelerator (often called Reverse
Proxy) is an application that stores (caches) documents that have been
requested over the HTTP protocol.

Based on certain criteria the next client requesting the document is either
given the cached document, or a "fresh" document requested from a backend
server. The purpose of this is to minimize the requests going to the backend
server(s) by serving the same document to potentially many users.


Authors:
--------
    Poul-Henning Kamp <phk@phk.freebsd.dk>


%package -n libvarnishapi1
Group: Productivity/Networking/Web/Proxy
Conflicts:	libvarnish0
Conflicts:	libvarnish1

#
Summary: Shared libraries for Varnish
%description -n libvarnishapi1
Varnish is an HTTP accelerator. An HTTP accelerator (often called Reverse
Proxy) is an application that stores (caches) documents that have been
requested over the HTTP protocol.

Based on certain criteria the next client requesting the document is either
given the cached document, or a "fresh" document requested from a backend
server. The purpose of this is to minimize the requests going to the backend
server(s) by serving the same document to potentially many users.


This package holds the shared libraries for varnish.


Authors:
--------
    Poul-Henning Kamp <phk@phk.freebsd.dk>


%package devel
Group: Development/Libraries/C and C++
Summary: Development files for Varnish
Requires: %{name} = %{version}
Requires: pcre-devel

%description devel
Varnish is an HTTP accelerator. An HTTP accelerator (often called Reverse
Proxy) is an application that stores (caches) documents that have been
requested over the HTTP protocol.

Based on certain criteria the next client requesting the document is either
given the cached document, or a "fresh" document requested from a backend
server. The purpose of this is to minimize the requests going to the backend
server(s) by serving the same document to potentially many users.


This package holds the development files for varnish.


Authors:
--------
    Poul-Henning Kamp <phk@phk.freebsd.dk>


%debug_package
%prep
%setup -n %{name}-%{pversion} 
%patch0
# fix for suse fillup
%if 0%{?suse_version}
%patch2
%endif

touch AUTHORS COPYING NEWS

%build
##autoreconf -fi
%if 0%{?suse_version} > 1000
export CFLAGS="%{optflags} -fstack-protector"
%endif
%configure --disable-static --localstatedir=%{_var}/cache/ \
           --enable-debugging-symbols \
           --enable-developer-warnings
%{__make}

%install
%makeinstall
find %{buildroot} -ls
#
# remove unneeded files
# libvarnish.la has -lrt as dependency lib
#%{__rm} -fv %{buildroot}%{_libdir}/*.la
#
# missing directories
%{__install} -d -m 0755 %{buildroot}{%{pkg_logdir},%{pkg_home}}
%{__install} -D -m 0644 redhat/varnish.logrotate %{buildroot}/etc/logrotate.d/varnish
%if 0%{?suse_version}
#
# init scripts
%{__install} -D -m 0644 redhat/varnish.sysconfig %{buildroot}/var/adm/fillup-templates/sysconfig.%{name}
%{__install} -D -m 0755 %{S:2} %{buildroot}%{_sysconfdir}/init.d/%{name}
%{__ln_s} -f %{_sysconfdir}/init.d/%{name} %{buildroot}%{_sbindir}/rc%{name}
#
# config files
%{__install} -D -m 0644 etc/default.vcl %{buildroot}%{_sysconfdir}/%{name}/default.vcl
%{__install} -D -m 0644 etc/default.vcl %{buildroot}%{_sysconfdir}/%{name}/default.vcl.example
echo %{varnish_backend_secret} > %{buildroot}%{_sysconfdir}/%{name}/secret
%else
#
# init scripts
%{__install} -D -m 0644 redhat/varnish.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/%{name}
%{__install} -D -m 0755 redhat/varnish.initrc    %{buildroot}%{_sysconfdir}/init.d/%{name}
#
# config files
%{__install} -D -m 0644 etc/default.vcl %{buildroot}%{_sysconfdir}/%{name}/default.vcl
%{__install} -D -m 0644 etc/default.vcl %{buildroot}%{_sysconfdir}/%{name}/default.vcl.example
echo %{varnish_backend_secret} > %{buildroot}%{_sysconfdir}/%{name}/secret
# directorys
%{__install} -m 0755 -d %{buildroot}%{pkg_cachedir}
%endif
%{__install} -m 0755 -d %{buildroot}%{_var}/run/%{name}
%{__install} -m 0755 -d %{buildroot}/var/log/varnish

%clean
%{__rm} -rf %{buildroot}

%pre
/usr/sbin/groupadd -r %{pkg_name} &>/dev/null ||:
/usr/sbin/useradd -g %{pkg_name} -s /bin/false -r -c "user for %{pkg_name}" -d %{pkg_home} %{pkg_name} &>/dev/null ||:

%if 0%{?suse_version}
%post
%fillup_and_insserv %{pkg_name}

%preun
%stop_on_removal %{pkg_name}

%postun
%restart_on_update %{pkg_name}
%{insserv_cleanup}
%else
# how to do the same for RH/mandriva?
%endif

%post -n libvarnishapi1 -p /sbin/ldconfig

%postun -n libvarnishapi1 -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%if 0%{?suse_version}
%{_sbindir}/rc%{name}
/var/adm/fillup-templates/sysconfig.%{name}
%else
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%endif
%config(noreplace) %{_sysconfdir}/init.d/%{name}
#
%dir %attr(750,%{pkg_name},%{pkg_name}) %{_sysconfdir}/%{name}/
%config(noreplace) %attr(640,%{pkg_name},%{pkg_name}) %{_sysconfdir}/%{name}/secret
%config(noreplace) %attr(640,%{pkg_name},%{pkg_name}) %{_sysconfdir}/%{name}/default.vcl
%config            %attr(640,%{pkg_name},%{pkg_name}) %{_sysconfdir}/%{name}/default.vcl.example
%dir %attr(750,%{pkg_name},%{pkg_name}) %{_var}/run/%{name}/
#
%{_sbindir}/varnishd
%{_sbindir}/varnishhist
%{_sbindir}/varnishlog
%{_sbindir}/varnishncsa
%{_sbindir}/varnishstat
%{_sbindir}/varnishtop
%{_sbindir}/varnishadm
%{_sbindir}/varnishreplay
%{_sbindir}/varnishsizes
%{_sbindir}/varnishtest
%{_mandir}/man1/varnishadm.1*
%{_mandir}/man1/varnishreplay.1*
%{_mandir}/man1/varnishd.1*
%{_mandir}/man1/varnishhist.1*
%{_mandir}/man1/varnishlog.1*
%{_mandir}/man1/varnishncsa.1*
%{_mandir}/man1/varnishsizes.1*
%{_mandir}/man1/varnishstat.1*
%{_mandir}/man1/varnishtop.1*
%{_mandir}/man1/varnishtest.1*
%{_mandir}/man7/vcl.7*
%{_mandir}/man3/vmod_std.3*
%{_mandir}/man7/varnish-cli.7*
%{_mandir}/man7/varnish-counters.7*
%doc ChangeLog LICENSE README
%if ! 0%{?suse_version}
%doc redhat/README.redhat
%endif
%dir %attr(750,%{pkg_name},%{pkg_name}) %{pkg_home}
%dir %attr(750,%{pkg_name},%{pkg_name}) %{pkg_cachedir}
%config /etc/logrotate.d/varnish
%dir /var/log/varnish
%dir %{_libdir}/varnish
%{_libdir}/varnish/libvarnish.so
%{_libdir}/varnish/libvcl.so
%{_libdir}/varnish/libvarnishcompat.so
%{_libdir}/varnish/libvgz.so
%dir %{_libdir}/varnish/vmods
%{_libdir}/varnish/vmods/libvmod_std.so

%files -n libvarnishapi1
%defattr(-,root,root,-)
%{_libdir}/libvarnishapi.so.1
%{_libdir}/libvarnishapi.so.1.0.0

%files devel
%defattr(-,root,root,-)
%{_includedir}/varnish/
%{_libdir}/pkgconfig/varnishapi.pc
%{_libdir}/varnish/libvarnish.la
%{_libdir}/libvarnishapi.la
%{_libdir}/libvarnishapi.so
%{_libdir}/varnish/libvcl.la
%{_libdir}/varnish/libvarnishcompat.la
%{_libdir}/varnish/libvgz.la
%{_libdir}/varnish/vmods/libvmod_std.la

%changelog
* Sun Jul 21 2013 cs@linux-administrator.com
- update to varnish 3.0.4
* Mon Sep 24 2012 cs@linux-administrator.com
- update to varnish 3.0.3
* Sat Dec 17 2011 cs@linux-administrator.com
- update to varnish 3.0.2
* Thu Sep  8 2011 cs@linux-administrator.com
- update to varnish 3.0.1
* Sat Jul  2 2011 cs@linux-administrator.com
- update to varnish 3.0.0
* Sun Jan 30 2011 cs@linux-administrator.com
- update to varnish 2.1.5
- adapted sysconfig patch
